library stubber;
import 'dart:convert';
import 'dart:io';
import 'package:mock_web_server/mock_web_server.dart';
class Stubber {
  MockWebServer _mockWebServer = MockWebServer(port: 8081);
  List<Stub> stubs=[];
  start() async {
    await _mockWebServer.start();
    _mockWebServer.dispatcher = _dispatcher;
  }
  stop() async {
    _mockWebServer.shutdown();
  }
  stub(Stub stub){
    stubs.add(stub);
  }
  Future<MockResponse> _dispatcher(HttpRequest request) async {
    for(var _stub in stubs){
      if(_stub.url == request.uri.toString()){
        return MockResponse()
            ..httpCode = _stub._response._statusCode
            ..body = _stub._response._body
            ..headers = _stub._response.headers;
      }
    }
    return _defaultAnswer;
  }
  get _defaultAnswer => MockResponse()..httpCode = 404;
}
class Stub{
  final String url;
  final Response _response;

  Stub(this.url, this._response);
}
class Response {
  int _statusCode;
  String _body;
  Map<String, String> headers;

  Response(this._statusCode, this._body, {this.headers});
}
/// A Calculator.
class Calculator {
  /// Returns [value] plus 1.
  int addOne(int value) => value + 1;
}
